#include "Vram.h"
#include "Chars.h"

extern byte[] MonoChars, ColorChars, Ascii, FenceChars;
extern byte[] LineChars;

void InitVram()
{
    MakePatternMono(Char_Ascii, Ascii, 0x40, 7);
    MakePatternMono(Char_Logo, MonoChars + (Char_Logo - Char_Logo) * CharHeight, 16, 5);
    MakePatternMono(Char_Star, MonoChars + (Char_Star - Char_Logo) * CharHeight, 2, 7);
    MakePatternMono(Char_EnemyBullet, MonoChars + (Char_EnemyBullet - Char_Logo) * CharHeight, 1, 6);
    MakePatternColor(Char_Enemy, ColorChars, Char_End - Char_Enemy);
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


word Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
    return vram + 2 * VramStep - VramRowSize * 2;
}


word Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
    return vram + 2 * VramStep - VramRowSize * 2;
}
